<template>
  <div>
    <MglMarker
      ref="marker"
      :coordinates="coordinates"
      :draggable="draggable"
      @dragend="dragEnd"
      @dblclick.stop.prevent
    >
      <svg
        slot="marker"
        :viewbox="viewBox"
        :width="radius * 2 + 4"
        :height="radius * 2 + 4"
      >
        <circle
          stroke="red"
          fill="transparent"
          stroke-width="1.5px"
          :cx="radius + 2"
          :cy="radius + 2"
          :r="radius"
        />
        <path
          v-if="visited"
          :d="checkPath"
          stroke-width="5"
          fill="transparent"
          stroke="green"
        />
      </svg>

      <slot :radius="radius" />
    </MglMarker>
    <MglMarker
      :coordinates="coordinates"
      anchor="bottom-left"
      :offset="labelOffset"
      v-if="name"
      :key="`l-${radius}`"
    >
      <div slot="marker" class="name-label">{{ name }}</div>
    </MglMarker>
  </div>
</template>
<style lang="scss" scoped>
.name-label {
  color: red;
}
</style>
<script>
const metersToPixels = (meters, latitude, zoom) =>
  meters / (78271.484 / 2 ** zoom) / Math.cos((latitude * Math.PI) / 180);

export default {
  props: {
    value: {},
    draggable: {
      default: false,
    },
    visited: {
      default: null,
    },
  },
  data() {
    return {
      radius: 10,
    };
  },
  inject: ["map"],
  mounted() {
    this.map.on("zoom", this.zoomed);
    this.zoomed();
  },
  beforeDestroy() {
    this.map.off("zoom", this.zoomed);
  },
  watch: {
    "value.radius": "zoomed",
  },
  computed: {
    labelOffset() {
      return [this.radius * 1.1, 0];
    },
    checkPath() {
      const factor = this.radius / 12;
      return `M${5 * factor},${10 * factor} L${12 * factor},${16 * factor} L${
        24 * factor
      },0`;
    },
    viewBox() {
      return `0 0 ${this.radius * 2 + 4} ${this.radius * 2 + 4}`;
    },
    coordinates() {
      return [this.value.lng, this.value.lat];
    },
    name() {
      return this.value && this.value.name;
    },
  },
  methods: {
    zoomed() {
      let zoom = this.map.getZoom();

      let radius = metersToPixels(
        this.value.radius || 100,
        this.value.lat,
        zoom
      );

      this.radius = Math.floor(Math.max(10, radius));
    },
    togglePopup() {
      if (this.$refs.marker) {
        return this.$refs.marker.togglePopup();
      } else {
        this.$nextTick(() =>
          this.$nextTick(() => {
            if (this.$refs.marker) this.$refs.marker.togglePopup();
          })
        );
      }
    },
    dragEnd(event) {
      const { lat, lng } = event.marker.getLngLat();

      if (this.$listeners.input) {
        this.$emit("input", { ...this.value, lat, lng });
      } else {
        this.value.lat = lat;
        this.value.lng = lng;
      }
    },
  },
};
</script>
